package ru.dbotthepony.mc.otm.data.world

import net.minecraft.util.RandomSource
import net.minecraft.util.valueproviders.FloatProvider
import net.minecraft.util.valueproviders.FloatProviderType
import ru.dbotthepony.mc.otm.registry.data.MNumberProviders

class OneOfFloatProvider(private val provider: OneOfProvider<FloatProvider>) : FloatProvider() {
	override fun sample(random: RandomSource): Float {
		return provider.select(random).sample(random)
	}

	override fun getMinValue(): Float {
		return provider.children.minOf { it.minValue }
	}

	override fun getMaxValue(): Float {
		return provider.children.minOf { it.maxValue }
	}

	override fun getType(): FloatProviderType<*> {
		return MNumberProviders.ONE_OF_FLOAT
	}

	companion object {
		@JvmStatic
		fun of(vararg providers: FloatProvider): OneOfFloatProvider {
			return OneOfFloatProvider(OneOfProvider.of(*providers))
		}

		@JvmStatic
		fun of(providers: Collection<FloatProvider>): OneOfFloatProvider {
			return OneOfFloatProvider(OneOfProvider.of(providers))
		}

		val CODEC = OneOfProvider.createCodec(FloatProvider.CODEC, ::OneOfFloatProvider, OneOfFloatProvider::provider)
	}
}
